<!-- ADI ad9361 FMC cards, officially named AD_FMCOMMS2-EBZ/AD_FMCOMMS3-EBZ
     This card definition maps the devices' signals to the slot's signals

     The ad9361 chip is supported by other device workers, in hdl/devices/ad9361*

     In addition to the ad9361 config device, this "card" also has;
     - AD7291BCPZ 8 channel ADC for monitoring power supplies and temperation, on the I2C
     - M24C02-WDW6TP 256x8 EEPROM also on I2C
     - Several voltage regulators that are not programmable or observable except via the above ADC

     So we have 3 devices: ad9361 (SPI), ad7291(I2C), and stm_mc24C02(I2C)

     Since the ad9361 is such a multifunction device it uses multiple device workers

     ad9361_config.hdl
     ad9361_adc.hdl, ad9361_adc.hdl, ad9361_adc_sub.hdl for the 2-channel ADC
     ad9361_dac.hdl, ad9361_dac.hdl, ad9361_dac_sub.hdl for the 2-channel DAC
     ad9361_data_sub.hdl for sharing multiple wires between these functions
     ad9361_spi.hdl for SPI bus
     fmcomms_2_3_i2c.hdl for I2C bus

     While the ad9361 has lots of clocking and data options, none of them are restricted nor controlled by the fmcomms2/3
     since all the signals are wired directly to the FPGA except the crystal.
-->
<card type="fmc_lpc">
  <device worker='ad9361_adc'/>
  <device worker='ad9361_adc'/>
                                                  <!--ad9361 ad9361     
                                                        pin  name -->
  <device worker='ad9361_adc_sub'>
    <property name='LVDS_p' value='true'/> <!-- signals go through a connector so LVDS is the default -->

    <!-- TODO / FIXME - enable these properties, there is currently a bug
         preventing them from being enabled -->

    <!-- The LVDS configuration is not a hard requirement but it is included
         here since it is recommended by Analog Devices for FMCOMMS2/3 -->
    <!--Property name='iostandard'  value='LVDS'/-->

    <!-- value must be dual when iostandard parameter value is LVDS -->
    <!--Property name='port_config'      value='dual'/-->

    <!-- value must be full_duplex when iostandard parameter value is LVDS-->
    <!--Property name='duplex_config'    value='full_duplex'/-->

    <!-- value must be DDR when iostandard parameter value is LVDS -->
    <!--Property name='data_rate_config' value='DDR'/-->

  </device>

  <device worker='ad9361_dac'/>
  <device worker='ad9361_dac'/>
  <device worker='ad9361_dac_sub'>
    <property name='LVDS_p' value='true'/> <!-- signals go through a connector so LVDS is the default -->

    <!-- TODO / FIXME - enable these properties, there is currently a bug
         preventing them from being enabled -->

    <!-- The LVDS configuration is not a hard requirement but it is included
         here since it is recommended by Analog Devices for FMCOMMS2/3 -->
    <!--Property name='iostandard'  value='LVDS'/-->

    <!-- value must be dual when iostandard parameter value is LVDS -->
    <!--Property name='port_config'      value='dual'/-->

    <!-- value must be full_duplex when iostandard parameter value is LVDS-->
    <!--Property name='duplex_config'    value='full_duplex'/-->

    <!-- value must be DDR when iostandard parameter value is LVDS -->
    <!--Property name='data_rate_config' value='DDR'/-->

  </device>
  <device worker='ad9361_spi'>
    <Signal name='SPI_DI'      slot='LA27_P'/>    <!--  C26  -->
    <Signal name='SPI_CLK'     slot='LA26_N'/>    <!--  D27  -->
    <Signal name='RESETB'      slot='LA28_P'/>    <!--  H31  -->
    <Signal name='SPI_ENB'     slot='LA26_P'/>    <!--  D26  -->
    <Signal name='SPI_DO'      slot='LA27_N'/>    <!--  C27  -->
  </device>
  <device worker='ad9361_data_sub'>
    <property name='LVDS_p' value='true'/>
    <property name='DATA_CLK_Delay' value='3'/>
    <property name='FB_CLK_Delay' value='7'/>
    <Signal name='DATA_CLK_P'  slot='LA00_P_CC'/> <!--  G11  -->
    <Signal name='DATA_CLK_N'  slot='LA00_N_CC'/> <!--  H11  -->
    <Signal name='P0_D_5_0(0)'     slot='LA11_N'/>    <!--  H17  TX_D0_N -->
    <Signal name='P0_D_5_0(1)'     slot='LA11_P'/>    <!--  H16  TX_D0_P -->
    <Signal name='P0_D_5_0(2)'     slot='LA12_N'/>    <!--  G16  TX_D1_N -->
    <Signal name='P0_D_5_0(3)'     slot='LA12_P'/>    <!--  G15  TX_D1_P -->
    <Signal name='P0_D_5_0(4)'     slot='LA13_N'/>    <!--  D18  TX_D2_N -->
    <Signal name='P0_D_5_0(5)'     slot='LA13_P'/>    <!--  D17  TX_D2_P -->
    <Signal name='P0_D_11_6(0)'     slot='LA10_N'/>    <!--  C15  TX_D3_N -->
    <Signal name='P0_D_11_6(1)'     slot='LA10_P'/>    <!--  C14  TX_D3_P -->
    <Signal name='P0_D_11_6(2)'     slot='LA14_N'/>    <!--  C19  TX_D4_N -->
    <Signal name='P0_D_11_6(3)'     slot='LA14_P'/>    <!--  C18  TX_D4_P -->
    <Signal name='P0_D_11_6(4)'    slot='LA15_N'/>    <!--  H20  TX_D5_N -->
    <Signal name='P0_D_11_6(5)'    slot='LA15_P'/>    <!--  H19  TX_D5_P -->
    <Signal name='P1_D_5_0(0)'     slot='LA02_N'/>    <!--  H8   RX_D0_N -->
    <Signal name='P1_D_5_0(1)'     slot='LA02_P'/>    <!--  H7   RX_D0_P -->
    <Signal name='P1_D_5_0(2)'     slot='LA03_N'/>    <!--  G10  RX_D1_N -->
    <Signal name='P1_D_5_0(3)'     slot='LA03_P'/>    <!--  G9   RX_D1_P -->
    <Signal name='P1_D_5_0(4)'     slot='LA04_N'/>    <!--  H11  RX_D2_N -->
    <Signal name='P1_D_5_0(5)'     slot='LA04_P'/>    <!--  H10  RX_D2_P -->
    <Signal name='P1_D_11_6(0)'     slot='LA05_N'/>    <!--  D12  RX_D3_N -->
    <Signal name='P1_D_11_6(1)'     slot='LA05_P'/>    <!--  D11  RX_D3_P -->
    <Signal name='P1_D_11_6(2)'     slot='LA06_N'/>    <!--  C11  RX_D4_N -->
    <Signal name='P1_D_11_6(3)'     slot='LA06_P'/>    <!--  C10  RX_D4_P -->
    <Signal name='P1_D_11_6(4)'    slot='LA07_N'/>    <!--  H14  RX_D5_N -->
    <Signal name='P1_D_11_6(5)'    slot='LA07_P'/>    <!--  H13  RX_D5_P -->

    <Signal name='RX_FRAME_P'  slot='LA01_P_CC'/> <!--  G8   -->
    <Signal name='RX_FRAME_N'  slot='LA01_N_CC'/> <!--  G7   -->
    <Signal name='FB_CLK_P'    slot='LA08_P'/>    <!--  G12  -->
    <Signal name='FB_CLK_N'    slot='LA08_N'/>    <!--  G13  -->
    <Signal name='TX_FRAME_P'  slot='LA09_P'/>    <!--  D14  -->
    <Signal name='TX_FRAME_N'  slot='LA09_N'/>    <!--  D15  -->
    <!-- TODO / FIXME - enable this property, there is currently a bug
         preventing it from being enabled -->
    <!-- The LVDS configuration is not a hard requirement but it is included
         here since it is recommended by Analog Devices for FMCOMMS2/3 -->
    <!--Property name='P0_P1_ARE_SWAPPED_p' value='false'/-->
    <!--Property name='DIFFERENTIAL_p'      value='true'/-->
    <!--Property name='PORT_CONFIG_p'       value='dual'/-->
    <!--Property name='DUPLEX_CONFIG_p'     value='full_duplex'/-->
    <Property name='LVDS_p' value='true'/>
  </device>
  <device worker='ad9361_config'>
    <property name='pin_control_p' value='true'/>
    <Signal name='TXNRX'  slot='LA16_N'/>    <!--  H4   -->
    <Signal name='ENABLE' slot='LA16_P'/>    <!--  G6   -->
  </device>
  <!-- the ad7291 and mc24c02 are just an I2C slave devices so there are no specific pins -->
  <device worker='ad7291'>
    <Signal name='ALERT' slot=''/>
    <Signal name='PD_RST_N' slot=''/>
  </device>
  <device worker='stm_mc24c02'/>
  <device worker='fmcomms_2_3_i2c'>
    <Signal name='SCL'        slot='SCL'/>        <!--  C30 -->
    <Signal name='SDA'        slot='SDA'/>        <!--  C31 -->
  </device>
</card>
